module NgaExtensions
  module Hash
    def select_keys *args
      select {|k,v| args.include?(k) || args.include?(k.to_sym)}
    end
    def reject_keys *args
      reject {|k,v| args.include?(k) || args.include?(k.to_sym)}
    end
    def forceUTF8!
      self.hmap do |k,v|
        { k => v.respond_to?(:force_encoding) ? v.force_encoding('UTF-8') : v }
      end
      self
    end
    def hmap(&block)
      self.inject({}){ |hash,(k,v)| hash.merge( block.call(k,v) ) }
    end
    def to_array_of_hashes
      self.inject([]) do |array,(k,v)|
        array << {k => v}
        array
      end
    end
  end
end

